#!/usr/bin/perl
#
# junky script to extract a DoABC2 tag
# usage: GetABC2.pl src.swf dst.abc
#
# ADOBE SYSTEMS INCORPORATED
# Copyright 2008 Adobe Systems Incorporated. All Rights Reserved.
#
# NOTICE:  Adobe permits you to use, modify, and distribute this file in
# accordance with the terms of the Adobe license agreement accompanying it.
# If you have received this file from a source other than Adobe, then your use,
# modification, or distribution of it requires the prior written permission of Adobe.
#

open(OUT, ">$ARGV[1]");
open(SWF, $ARGV[0]);
binmode(SWF);
binmode(OUT);

# skip hash-bang
read(SWF, $byte0, 1);

if($byte0 eq '#')
  { <SWF> } # read the line
else
  { seek(SWF, 0, 0) }

read(SWF, $head, 8);

if(substr($head, 0, 1) eq 'C')
{
  substr($head, 0, 1) = 'F';
  $temp = "$$.achacks.S";
  $use_zpipe = qx/which zpipe/;
  if($use_zpipe) {
    sys("zpipe", "<$SWF", ">$temp");
  }
  else {
    sys("zpipe.pl", "<$SWF", ">$temp");
  }
  close(SWF);
  open(SWF, "<$temp");
  binmode(SWF);
}

read(SWF, $rect1, 1);
$rbits = unpack("C", $rect1) >> 3;
$rrbytes = int((7 + ($rbits * 4) - 3) / 8);
read(SWF, $rectr, $rrbytes);
read(SWF, $frameRate, 2);
print "frame rate: " . unpack("v", $frameRate) / 256.0 . "\n";
read(SWF, $frameCount, 2);
print "frame count: " . unpack("v", $frameCount) . "\n";

do
{
  read(SWF, $code, 2);
  $code = unpack("v", $code);
  $tag = $code >> 6;
  $len = ($code & 0x3f);
  $bhead = 2;
  if($len == 0x3f)
  {
    read(SWF, $len, 4);
    $len = unpack("V", $len);
    $bhead += 4;
  }
  print "$tag : $len\n";
  if($tag == 82 || $tag == 72) # DoABC[2]
  {
    read(SWF, $data, $len);
    if($tag == 82)
    {
      $n = 4;
      while(substr($data, $n, 1) ne "\0")
        { $n++ }
      $n++; # null term
    }
    else
      { $n = 0 }
    print OUT substr($data, $n);
  }
  else
  {
    read(SWF, $data, $len);
  }
} while($tag != 0);
do
{
  read(SWF, $rest, 1);
} while(length($rest));
if($temp)
  { system("rm", $temp) }
