#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "AS3.h"

void flyield();

const char *TestThunkStr = NULL;

AS3_Val TestThunk(void *data, AS3_Val params)
{
  static char buf[256];

  sprintf(buf, "%p", data);
  sztrace(buf);
  TestThunkStr = buf;
  return NULL;
}

/* trace(new Date()); trace("foo");
   Wordy version with correct ref counting
*/
void TraceTest()
{
  AS3_Val DateClass = AS3_NSGetS(NULL, "Date");
  AS3_Val emptyParams = AS3_Array("");
  AS3_Val DateObj = AS3_New(DateClass, emptyParams);
  AS3_Val trace = AS3_NSGetS(NULL, "trace");
  AS3_Val fooParams = AS3_Array("StrType", "foo");
  AS3_Val traceParams = AS3_Array("AS3ValType", DateObj);

  /* trace(new Date()) */
  AS3_Release(AS3_Call(trace, AS3_Undefined(), traceParams));
  /* trace("foo") */
  AS3_Release(AS3_Call(trace, AS3_Undefined(), fooParams));

  AS3_Release(traceParams);
  AS3_Release(fooParams);
  AS3_Release(trace);
  AS3_Release(DateObj);
  AS3_Release(emptyParams);
  AS3_Release(DateClass);
}

int main()
{
  /* to perusers -- this test leaks like a sieve!
     all AS3_Vals EXCEPT one passed to your Thunk
     must be AS3_Release-ed
     and char *s must be free-ed!
  */
  fprintf(stderr, "Starting\n");
  fprintf(stderr, "typeof Date: %s\n",
    AS3_TypeOf(AS3_NSGetS(NULL, "Date")));
  fprintf(stderr, "typeof trace: %s\n",
    AS3_TypeOf(AS3_NSGetS(NULL, "trace")));
  fprintf(stderr, "typeof string: %s\n",
    AS3_TypeOf(AS3_String("foo")));
  fprintf(stderr, "typeof int: %s\n",
    AS3_TypeOf(AS3_Int(56)));
  fprintf(stderr, "string: %s\n",
    AS3_StringValue(AS3_String("foobar")));
  fprintf(stderr, "int: %d\n",
    AS3_IntValue(AS3_Int(1234)));
  fprintf(stderr, "number: %f\n",
    AS3_NumberValue(AS3_Number(12.34)));
  fprintf(stderr, "true: %s\n",
    AS3_StringValue(AS3_True()));
  fprintf(stderr, "false: %s\n",
    AS3_StringValue(AS3_False()));
  fprintf(stderr, "null: %s\n",
    AS3_StringValue(AS3_Null()));
  fprintf(stderr, "undefined: %s\n",
    AS3_StringValue(AS3_Undefined()));
  fprintf(stderr, "[1,true,\"foo\"]: %s\n",
    AS3_StringValue(AS3_Array("IntType,AS3ValType,StrType",
      1, AS3_True(), "foo")));
  fprintf(stderr, "trace([1,true,\"foo\")\n");
  AS3_Call(AS3_NSGetS(NULL, "trace"), AS3_Undefined(),
    AS3_Array("IntType,AS3ValType,StrType", 1, AS3_True(), "foo"));
  fprintf(stderr, "trace(null)\n");
  AS3_Call(AS3_NSGetS(NULL, "trace"), AS3_Undefined(), AS3_Array("AS3ValType",
      AS3_Null()));
  fprintf(stderr, "Date: %s\n",
    AS3_StringValue(AS3_NSGetS(NULL, "Date")));
  fprintf(stderr, "AS3_Array(\"\"): %s\n",
    AS3_StringValue(AS3_Array("")));
  fprintf(stderr, "Date: %s\n",
    AS3_StringValue(AS3_New(AS3_NSGetS(NULL, "Date"), AS3_Array(""))));
  fprintf(stderr, "setTimeout Thunk\n");
  AS3_Call(AS3_NSGetS(AS3_String("flash.utils"), "setTimeout"), AS3_Undefined(),
    AS3_Array("AS3ValType,IntType",
    AS3_Function((void *)345, &TestThunk), 2000));
  while(!TestThunkStr)
    flyield();
  fprintf(stderr, "TT: %s\n", TestThunkStr);
  TraceTest();
  {
    AS3_Val ArrayClass = AS3_NSGetS(NULL, "Array");
    AS3_Val DateClass = AS3_NSGetS(NULL, "Date");
    fprintf(stderr, "(new Array()) instanceof Array: %d\n",
      AS3_InstanceOf(AS3_Array(""), ArrayClass));
    fprintf(stderr, "(new Array()) instanceof Date: %d\n",
      AS3_InstanceOf(AS3_Array(""), DateClass));
  }
  {
    int a, b;
    double d;
    char *s;
    char *templ = "IntType,IntType,DoubleType,StrType";

    AS3_ArrayValue(AS3_Array(templ, 12, 34, 56.78, "foo"), templ,
      &a, &b, &d, &s);
    fprintf(stderr, "%d %d %f %s\n", a, b, d, s);
  }
  {
    int a, b;
    double d;
    char *s;
    char *templ = "a:IntType,b:IntType,d:DoubleType,s:StrType";

    AS3_ObjectValue(AS3_Object(templ, 12, 34, 56.78, "foo"), templ,
      &a, &b, &d, &s);
    fprintf(stderr, "%d %d %f %s\n", a, b, d, s);
  }
  fprintf(stderr, "Testing ByteArray_writeBytes...\n");
  {
    char buf[256] = "Some string!";
    AS3_Val baNS = AS3_String("flash.utils");
    AS3_Val baClass = AS3_NSGetS(baNS, "ByteArray");
    AS3_Val emptyParams = AS3_Array("");
    AS3_Val ba = AS3_New(baClass, emptyParams);
    AS3_Val readUTFBytes = AS3_GetS(ba, "readUTFBytes");
    AS3_Val lenParams = AS3_Array("IntType", strlen(buf));
    AS3_Val str;

    // copy some string into ba
    AS3_ByteArray_writeBytes(ba, buf, strlen(buf));
    AS3_SetS(ba, "position", AS3_Int(0));
    str = AS3_Call(readUTFBytes, ba, lenParams);
    sztrace("--- ByteArray_writeBytes");
    AS3_Trace(str);
  }
  fprintf(stderr, "Testing ByteArray_readBytes...\n");
  {
    char buf[256];
    AS3_Val baNS = AS3_String("flash.utils");
    AS3_Val baClass = AS3_NSGetS(baNS, "ByteArray");
    AS3_Val emptyParams = AS3_Array("");
    AS3_Val ba = AS3_New(baClass, emptyParams);
    AS3_Val writeUTFBytes = AS3_GetS(ba, "writeUTFBytes");
    AS3_Val len;

    AS3_Call(writeUTFBytes, ba, AS3_Array("StrType", "Some other string!"));
    AS3_SetS(ba, "position", AS3_Int(0));
    len = AS3_GetS(ba, "length");
    AS3_ByteArray_readBytes(buf, ba, AS3_IntValue(len));
    buf[AS3_IntValue(len)] = 0;
    fprintf(stderr, "%s\n", buf);
  }
  fprintf(stderr, "Testing malloc...\n");
  {
    int size = 4096;

    while(1)
    {
      void *b = sbrk(0);
      void *p = malloc(size);
      if(!p)
      {
        fprintf(stderr, "malloc %x: %p %p\n", size, b, sbrk(0));
        break;
      }
      free(p);
      if(size >= 64 * 1024 * 1024)
        break;
      if(!(size % (1024 * 1024)))
        fprintf(stderr, "%d...\n", size);
      size += 4096;
    }
  }
  fprintf(stderr, "Done\n");
  return 0;
}
